"""
    Ubiquity REST API

    Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar  #### Testnet Testnet support coming soon  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.   # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@blockdaemon.com
    Generated by: https://openapi-generator.tech
"""

import json
import unittest

import test.mock
import test.utils
import ubiquity
from ubiquity.api import (
    transactions_api,
    ApiClient,
)
from ubiquity.ubiquity_openapi_client.model.signed_tx import SignedTx
from ubiquity import Configuration

import httpretty
import urllib3


class TestTransactionsApi(unittest.TestCase):
    """TransactionsApi unit test stubs"""
    def setUp(self):
        self.api_client = ApiClient(Configuration())
        self.api_instance = transactions_api.TransactionsApi(
            self.api_client)  # noqa: E501
        self.protocols = test.utils.get_protocols()
        self.accounts_by_protocol = {
            "algorand":
                "5K6J3Z54656IR7YY65WNJT54UW6RBZZYL5LWQUTG4RWOTRTRBE2MR2AODQ",
            "bitcoin": "bc1q0e3vshzcp8kntj2ynqaxt32sqshqf36tl8xdmz",
            "ethereum": "0x30B2f83e291f952850DFB13380F6c71b24FDF97c",
            "polkadot": "1622aMEugx8d9FMEPJaknxCR5eUXSCJA5GANhdxYxwgA29vH",
            "stellar":
                "GDJ5VRKEVCDDFQPI3UYAJPU35NHPCML3JCFYH7J456GAOAL3NKVSE7YM",
            "xrp": "rh3VLyj1GbQjX7eA15BwUagEhSrPHmLkSR"
        }  # noqa: E

    def tearDown(self):
        pass

    # Helper methods

    def get_transactions_endpoints(self, network, path, supported_protocols,
                                   transactions_by_protocol):
        endpoints_data_protocols = []
        parsed_transactions_protocols = []
        for protocol in supported_protocols:
            parsed_transactions = json.loads(
                transactions_by_protocol[protocol])
            parsed_transactions_protocols.append(parsed_transactions)
            endpoints_data_protocols.append({
                "req_url":
                f"/{protocol}/{network}/{'tx/' + parsed_transactions['items'][0]['id'] if path == 'tx' else path}",
                "method":
                httpretty.GET,
                "status":
                200,
                "response_data":
                json.dumps(parsed_transactions['items'][0])
                if path == "tx" else transactions_by_protocol[protocol]
            })
        return endpoints_data_protocols, parsed_transactions_protocols

    def get_transactions_by_supported_protocols(self, supported_protocols):
        return {
            protocol: test.mock.get_mock_file_content(
                f'transactions_api/get_txs_{protocol}.json')
            for protocol in supported_protocols
        }

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_get_txs(self):
        network = "mainnet"
        supported_protocols = test.mock.get_supported_protocols(
            self.protocols, "/txs")
        assert len(supported_protocols) > 0
        transactions_by_protocol = self.get_transactions_by_supported_protocols(
            supported_protocols)
        endpoints, _ = self.get_transactions_endpoints(
            network, "txs", supported_protocols, transactions_by_protocol)
        test.mock.setup_mock_server(self.api_client.configuration.host,
                                    endpoints)
        assert len(supported_protocols) > 0
        for protocol in supported_protocols:
            try:
                _ = self.api_instance.get_txs(protocol, network)
            except Exception as e:
                print('error when calling protocol', protocol)
                raise e

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_get_tx_by_id(self):
        network = "mainnet"
        supported_protocols = test.mock.get_supported_protocols(
            self.protocols, "/tx/:id")
        assert len(supported_protocols) > 0
        transactions_by_protocol = self.get_transactions_by_supported_protocols(
            supported_protocols)
        endpoints, parsed_transactions = self.get_transactions_endpoints(
            network, "tx", supported_protocols, transactions_by_protocol)
        test.mock.setup_mock_server(self.api_client.configuration.host,
                                    endpoints)
        assert len(supported_protocols) > 0
        for i, protocol in enumerate(supported_protocols):
            print("calling tx_by_id for protocol", protocol)
            try:
                _ = self.api_instance.get_tx_by_hash(
                    protocol, network,
                    parsed_transactions[i]['items'][0]['id'])
            except Exception as e:
                print('error when calling protocol', protocol)
                raise e

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_tx_send(self):
        protocol = "bitcoin"
        network = "testnet"

        endpoint = {
            "req_url":
            f"/{protocol}/{network}/tx/send",
            "method":
            httpretty.POST,
            "status":
            200,
            "response_data":
            test.mock.get_mock_file_content("transactions_api/send.json")
        }
        test.mock.setup_mock_server(self.api_client.configuration.host,
                                    [endpoint])

        raw_signed_tx = "0100000001aa3bec3844a9a49"
        signed_tx = SignedTx(tx=raw_signed_tx)

        tx = self.api_instance.tx_send(signed_tx, protocol, network)
        assert 'id' in tx
        assert tx[
            'id'] == "6d435b5cbfce209237ede9841586bbffbec5388a1c9da8b7879efe9e806e95b8"

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_get_txs_by_address(self):
        network = 'mainnet'
        supported_protocols = test.mock.get_supported_protocols(
            self.protocols, '/account/:address/txs')
        assert len(supported_protocols) > 0
        print("Supported protocols:", supported_protocols)

        for protocol in supported_protocols:
            account_id = self.accounts_by_protocol[protocol]

            test.mock.setup_mock_server(self.api_client.configuration.host, [{
                "req_url":
                    f"/{protocol}/{network}/account/{account_id}/txs",
                "method":
                    httpretty.GET,
                "status":
                    200,
                "response_data":
                    test.mock.get_mock_file_content(
                        f'balances__utxo_api/{protocol}_account_{account_id}_txs.json')
            }])
            _ = self.api_instance.get_txs_by_address(protocol, network, account_id)



if __name__ == '__main__':
    unittest.main()
